#[derive(Debug)]
enum BinaryTree<T> {
    Empty,
    Branch(Box<TreeNode<T>>)
}

#[derive(Debug)]
struct TreeNode<T> {
    element: T,
    left:  BinaryTree<T>,
    right: BinaryTree<T>
}


#[derive(Debug)]
enum BTree1<T> {
    Empty,
    Branch(T, Box<BTree1<T>>, Box<BTree1<T>>)
}


#[derive(Debug)]
enum BTree2<T> {
    Leaf   (T),
    Branch (T, Box<BTree2<T>>, Box<BTree2<T>>)
}


#[derive(Debug)]
enum BTree3<T> {
    Leaf   (T),
    Branch (Box<BTree3<T>>, Box<BTree3<T>>)
}


#[derive(Debug)]
enum BTree4<S,T> {
    Leaf   (S),
    Branch (T, Box<BTree4<S,T>>, Box<BTree4<S,T>>)
}


#[derive(Debug)]
enum BTree5<T> {
    Empty,
    Leaf   (T),
    Branch (Box<BTree5<T>>, Box<BTree5<T>>)
}


#[derive(Debug)]
enum BTree6<S,T> {
    Empty,
    Leaf   (S),
    Branch (T, Box<BTree6<S,T>>, Box<BTree6<S,T>>),
    Fork   (T, Box<BTree6<S,T>>, Box<BTree6<S,T>>)
}



fn main() {
    println!("{:?}", BTree1::Empty as BTree1<i32>);
    println!("{:?}", BTree2::Leaf(2));
    println!("{:?}", BTree3::Branch(Box::new(BTree3::Leaf(5)), 
                                    Box::new(BTree3::Leaf(6))));
}
